#!/usr/bin/perl

use strict;
use File::Basename;
use File::Spec;

my $directory = dirname("$0");

sub findFiles($$$) {
  if (-e "$_[0]") {
    my $fn = "$_[0]";
    if (($fn)&&($fn =~ s/^\Q$_[2]\E.//)) {
      push @{$_[1]}, "$fn";
    }

    if (-d "$_[0]") {
      my @subfiles = ();
      local *DIR;
      opendir *DIR, "$_[0]" or die("$_[0]: $!\n");
      while (my $file = readdir(*DIR)) {
        if (($file ne '.')&&($file ne '..')) {
          push @subfiles, "$file";
        }
      }
      closedir *DIR;

      foreach my $sd (@subfiles) {
        findFiles(File::Spec->catfile("$_[0]","$sd"), $_[1],$_[2]);
      }
    }
  }  
}

sub removeFromArray($$) {
  my @tmp = ();
  foreach my $e (@{$_[0]}) {
    if ($e ne $_[1]) {
      push @tmp, $e;
    }
  }
  @{$_[0]} = @tmp;
}

my @tmpcontent = ();
findFiles(File::Spec->catfile("$directory",'tmp'),\@tmpcontent,File::Spec->catfile("$directory",'tmp'));
die("no installable file found in debian/tmp\n") unless (@tmpcontent);

while (my $file = glob(File::Spec->catfile("$directory","*.install"))) {
  $file = basename("$file");
  $file =~ s/\.install$//;

  my $dir = File::Spec->catfile("$directory","$file");
  my @dircontent = ();
  findFiles("$dir",\@dircontent,"$dir");
  die("no installation directory found for $file\n") unless (@dircontent);

  foreach my $installedFile (@dircontent) {
    removeFromArray(\@tmpcontent, "$installedFile");
  }

}

if (@tmpcontent) {
  foreach my $f (@tmpcontent) {
    print STDERR "$f\n";
  }
}
else {
  print STDOUT "ok\n";
}
